# 4K-tris by Petr Blahos

## 1. Links

- [Back to overview](../README.md)
- [How to play](#5-how-to-play)
- [Archived files](https://github.com/nineteendo/tetris4karchive/tree/main/4k-tris/archive)
- [Source code](https://web.archive.org/20201007111205/https://sites.google.com/site/petrsstuff/projects/4ktris)

## 2. Summary

- **Programming language**: Java
- **Main size**: 4,1 KB
- **Extra size**: 0 B
- **Total size**: 4,1 KB
- **Feature count**: 23
- **Bytes per feature**: 178 B

## 3. Controls

- <kbd>Alt</kbd>+<kbd>F4</kbd> or <kbd>⌘ Cmd</kbd>+<kbd>Q</kbd>: quit

### 3.1. Game

- <kbd>↑</kbd>: rotate clockwise
- <kbd>←</kbd>: move left
- <kbd>↓</kbd>: hard drop
- <kbd>→</kbd>: move right

### 3.2. Game over screen

- <kbd>Page Up</kbd>: increase level
- <kbd>Page Down</kbd>: decrease level
- <kbd>Space</kbd>: retry

## 4. Features

1. **All tetrominoes**
2. **Animations**
3. **Colored pieces**
4. **Drop**: hard drop, piece falls at maximum speed
5. **Faster levels**: `speed = min(level, 25)`
6. **Game over detection**
7. **Game over screen**
8. **Gravity**
9. **Horizontal movement**
10. **Level score multiplier**
11. **Level selection**: start from level 1 - 25
12. **Line clearing**
13. **Line clear points**:
    - **Single**: `1 * level`
    - **Double**: `2 * level`
    - **Triple**: `3 * level`
    - **Tetris**: `4 * level`
14. **No bugs**
15. **No ceiling**
16. **Piece preview**: single piece
17. **Quit**: quit java
18. **Retry**
19. **Rotation**
20. **SFX**
21. **Shadows**
22. **Sleep mode**: from OS
23. **Smooth gravity**

## 5. How to play

1. [Download the archive](https://codeload.github.com/nineteendo/tetris4karchive/zip/refs/heads/main)
2. [Download Java](https://java.com/download)
3. Double click `4ktris-1.0.jar`