# Tetris 4K archive

This is an incomplete list of Tetris programs smaller than 4 KiB (4096 B), feel free to [contribute on GitHub](https://github.com/nineteendo/tetris4karchive).

## 1. Disclaimer

The Tetris® brand is owned by Tetris Holding, LLC, and The Tetris Company, Inc. The programs listed in this archive are created by various authors and contributors. As far as we know, no one has received permission or authorization from the rights holders, and latter is not the source, sponsor, or otherwise associated with these programs.

## 2. Overview

Here is a spreadsheet with more information (1 KB = 1000 B): [tetris-4k-archive.xlsx](tetris-4k-archive.xlsx).

### 2.1. Bytes per feature

1. [**4is 256 by Jan Kadlec**](4is-256/README.md): 16 B
2. [**TetrOS v1.05 by Tomasz Grysztar**](tetros-v105/README.md): 30 B
3. [**Binary Tetris by Bumpy**](binary-tetris/README.md): 30 B
4. [**Tetris 256B by Megasys**](tetris-256b/README.md): 32 B
5. [**Mini Tetris by Rebecca König**](mini-tetris/README.md): 33 B
6. [**Tiny Tetris by Dwing**](tiny-tetris/README.md): 34 B
7. [**Binary Tetris by Martin Kleppe**](binary-tetris-2/README.md): 34 B
8. [**Tinytris by Pellsson**](tinytris/README.md): 36 B
9. [**TetrOS by Daniel Etzold**](tetros/README.md): 45 B
10. [**Tetris 84 by Nice Zombies**](tetris-84/README.md): 46 B
11. [**Tetris (unknown author)**](tetris/README.md): 46 B
12. [**Tetranglix by XlogicX**](tetranglix/README.md): 49 B
13. [**Tetranglix by shikhin**](tetranglix-2/README.md): 56 B
14. [**256B Tetris Theme by Mathieu Henri**](256b-tetris-theme/README.md): 57 B
15. [**Binary Tetris by notjagan**](binary-tetris-3/README.md): 65 B
16. [**1½KB Tetris by Joris Zwart**](1.5kb-tetris/README.md): 71 B
17. [**1.32KB Tetris by Vzub Pnukem**](1.32kb-tetris/README.md): 75 B
18. [**Small Tetris by Tore Bastiansen**](small-tetris/README.md): 98 B
19. [**aSMtris by Sebastian Mihai**](asmtris/README.md): 119 B
20. [**Tetris Light by Arek Michowski**](tetris-light/README.md): 120 B
21. [**Tis by Thomas ten Cate**](tis/README.md): 130 B
22. [**Another Tetris 4K by flub**](another-tetris-4k/README.md): 154 B
23. [**Tetris by nitacku**](tetris-3/README.md): 157 B
24. [**Tetris by manatwork**](tetris-2/README.md): 161 B
25. [**Tetris by Andrew March**](tetris-5/README.md): 169 B
26. [**Tetris by mniip**](tetris-4/README.md): 170 B
27. [**4K-tris by Petr Blahos**](4k-tris/README.md): 178 B
28. [**Tetris 4K by wiesi**](tetris-4k/README.md): 182 B

### 2.2. Main size

1. [**256B Tetris Theme by Mathieu Henri**](256b-tetris-theme/README.md): 227 B
2. [**Tinytris by Pellsson**](tinytris/README.md): 251 B
3. [**4is 256 by Jan Kadlec**](4is-256/README.md): 256 B
4. [**Tetris 256B by Megasys**](tetris-256b/README.md): 256 B
5. [**Binary Tetris by Martin Kleppe**](binary-tetris-2/README.md): 274 B
6. [**Binary Tetris by Bumpy**](binary-tetris/README.md): 304 B
7. [**TetrOS by Daniel Etzold**](tetros/README.md): 446 B
8. [**Tetranglix by shikhin**](tetranglix-2/README.md): 446 B
9. [**Binary Tetris by notjagan**](binary-tetris-3/README.md): 457 B
10. [**Mini Tetris by Rebecca König**](mini-tetris/README.md): 464 B
11. [**Tiny Tetris by Dwing**](tiny-tetris/README.md): 471 B
12. [**Tetranglix by XlogicX**](tetranglix/README.md): 491 B
13. [**TetrOS v1.05 by Tomasz Grysztar**](tetros-v105/README.md): 508 B
14. [**Tetris (unknown author)**](tetris/README.md): 510 B
15. [**1½KB Tetris by Joris Zwart**](1.5kb-tetris/README.md): 1,3 KB
16. [**1.32KB Tetris by Vzub Pnukem**](1.32kb-tetris/README.md): 1,4 KB
17. [**Tetris 84 by Nice Zombies**](tetris-84/README.md): 1,5 KB
18. [**Tetris Light by Arek Michowski**](tetris-light/README.md): 1,8 KB
19. [**aSMtris by Sebastian Mihai**](asmtris/README.md): 1,9 KB
20. [**Small Tetris by Tore Bastiansen**](small-tetris/README.md): 2,0 KB
21. [**Tetris by Andrew March**](tetris-5/README.md): 2,7 KB
22. [**Tetris by manatwork**](tetris-2/README.md): 2,7 KB
23. [**Tetris by nitacku**](tetris-3/README.md): 2,8 KB
24. [**Tetris by mniip**](tetris-4/README.md): 2,9 KB
25. [**Another Tetris 4K by flub**](another-tetris-4k/README.md): 4,0 KB
26. [**Tetris 4K by wiesi**](tetris-4k/README.md): 4,0 KB
27. [**Tis by Thomas ten Cate**](tis/README.md): 4,0 KB
28. [**4K-tris by Petr Blahos**](4k-tris/README.md): 4,1 KB

### 2.3. Feature count

1. [**Tetris 84 by Nice Zombies**](tetris-84/README.md): 32
2. [**Tis by Thomas ten Cate**](tis/README.md): 31
3. [**Another Tetris 4K by flub**](another-tetris-4k/README.md): 26
4. [**4K-tris by Petr Blahos**](4k-tris/README.md): 23
5. [**Tetris 4K by wiesi**](tetris-4k/README.md): 22
6. [**Small Tetris by Tore Bastiansen**](small-tetris/README.md): 21
7. [**1½KB Tetris by Joris Zwart**](1.5kb-tetris/README.md): 18
8. [**1.32KB Tetris by Vzub Pnukem**](1.32kb-tetris/README.md): 18
9. [**Tetris by nitacku**](tetris-3/README.md): 18
10. [**TetrOS v1.05 by Tomasz Grysztar**](tetros-v105/README.md): 17
11. [**Tetris by manatwork**](tetris-2/README.md): 17
12. [**Tetris by mniip**](tetris-4/README.md): 17
13. [**4is 256 by Jan Kadlec**](4is-256/README.md): 16
14. [**aSMtris by Sebastian Mihai**](asmtris/README.md): 16
15. [**Tetris by Andrew March**](tetris-5/README.md): 16
16. [**Tetris Light by Arek Michowski**](tetris-light/README.md): 15
17. [**Mini Tetris by Rebecca König**](mini-tetris/README.md): 14
18. [**Tiny Tetris by Dwing**](tiny-tetris/README.md): 14
19. [**Tetris (unknown author)**](tetris/README.md): 11
20. [**Binary Tetris by Bumpy**](binary-tetris/README.md): 10
21. [**TetrOS by Daniel Etzold**](tetros/README.md): 10
22. [**Tetranglix by XlogicX**](tetranglix/README.md): 10
23. [**Tetris 256B by Megasys**](tetris-256b/README.md): 256 8
24. [**Binary Tetris by Martin Kleppe**](binary-tetris-2/README.md): 8
25. [**Tetranglix by shikhin**](tetranglix-2/README.md): 8
26. [**Tinytris by Pellsson**](tinytris/README.md): 7
27. [**Binary Tetris by notjagan**](binary-tetris-3/README.md): 7
28. [**256B Tetris Theme by Mathieu Henri**](256b-tetris-theme/README.md): 4
