# Another Tetris 4K by flub

## 1. Links

- [Back to overview](../README.md)
- [How to play](#5-how-to-play)
- [Archived files](https://github.com/nineteendo/tetris4karchive/tree/main/another-tetris-4k/archive)
- [Source code](https://github.com/netspooky/hardcode/tree/master/04096/java/t4k)

## 2. Summary

- **Programming language**: Java
- **Main size**: 4,0 KB
- **Extra size**: 0 B
- **Total size**: 4,0 KB
- **Feature count**: 26
- **Bytes per feature**: 154 B

## 3. Controls

- <kbd>Alt</kbd>+<kbd>F4</kbd> or <kbd>⌘ Cmd</kbd>+<kbd>Q</kbd>: quit

### 3.1. Game

- <kbd>P</kbd>: pause
- <kbd>S</kbd>: toggle music
- <kbd>↑</kbd>: rotate clockwise
- <kbd>Space</kbd>: hard drop
- <kbd>←</kbd>: move left
- <kbd>↓</kbd>: soft drop
- <kbd>→</kbd>: move right

### 3.2. Pause screen

- <kbd>Any Key</kbd>: unpause

### 3.3. Game over screen

- <kbd>Any Key</kbd>: retry

## 4. Features

1. **All tetrominoes**
2. **Alternative drop**
3. **Colored pieces**
4. **Drop**
5. **Faster levels**: `speed = level`
6. **Game over detection**
7. **Game over screen**: game over text
8. **Gravity**
9. **High scores**
10. **Horizontal movement**
11. **Line clearing**
12. **Line clear points**:
    - **Single**: 100
    - **Double**: 225
    - **Triple**: 375
    - **Tetris**: 500
13. **Music**: A-Type
14. **No bugs**
15. **No ceiling**
16. **Pause**
17. **Piece preview**: single piece
18. **Piece statistics**
19. **Placement points**: 10
20. **Quit**: quit java
21. **Retry**
22. **Rotation**
23. **Sleep mode**: from OS
24. **Title screen**
25. **Toggleable music**
26. **Wall kicks**

## 5. How to play

1. [Download the archive](https://codeload.github.com/nineteendo/tetris4karchive/zip/refs/heads/main)
2. [Download Java](https://java.com/download)
3. Run the following command, replacing `/path/to/AnotherTetris4K.jar`:
    ```shell
    java -cp /path/to/AnotherTetris4K.jar t4k
    ```