# aSMtris by Sebastian Mihai

## 1. Links

- [Back to overview](../README.md)
- [Showcase video](https://youtu.be/N1HQLLhWRfA)
- [How to play](#5-how-to-play)
- [Archived files](https://github.com/nineteendo/tetris4karchive/tree/main/asmtris/archive)
- [Source code](http://sebastianmihai.com/asmtris.html)

## 2. Summary

- **Programming language**: Assembly
- **Main size**: 1,9 KB
- **Extra size**: 0 B
- **Total size**: 1,9 KB
- **Feature count**: 16
- **Bytes per feature**: 119 B

## 3. Controls

### 3.1. Pause screen

- <kbd>F16</kbd>: pause
- <kbd>A</kbd>: move left
- <kbd>Q</kbd>: quit
- <kbd>S</kbd>: move right
- <kbd>Space</kbd>: rotate counterclockwise

### 3.2. Pause screen

- <kbd>Any Key</kbd>: unpause

## 4. Features

1. **All tetrominoes**
2. **Animations**
3. **Colored pieces**
4. **Controls guide**
5. **Game over detection**
6. **Game over screen**: game over text
7. **Gravity**
8. **Horizontal movement**
9. **Line clearing**
10. **No bugs**
11. **Pause**: pause emulation
12. **Piece preview**: single piece
13. **Placement transition**
14. **Quit**
15. **Rotation**
16. **Smooth gravity**

## 5. How to play

1. [Download the archive](https://codeload.github.com/nineteendo/tetris4karchive/zip/refs/heads/main)
2. [Download DOSBox](https://sourceforge.net/projects/dosbox/files/latest/download)
3. Move `aSMtris.com` to `~/dosgames`
4. [Setup AUTOEXEC](https://dosbox.com/wiki/AUTOEXEC)
5. Run the command for your operating system:
    - Windows:
        ```shell
        dosbox -c aSMtris
        ```
    - MacOS:
        ```shell
        /Applications/dosbox.app/Contents/MacOS/DOSBox -c aSMtris
        ```