# Tetris-84

Original version by nitacku: https://ticalc.org/archives/files/fileinfo/371/37183.html.

## 1. Videos

- [Showcase](https://youtu.be/eK8wsj_VT_w)
- [Tutorial (outdated)](https://youtu.be/ctYHvZmyS2I)

## 2. Files

- [**TETRIS.8xp**](TETRIS.8xp): TI-84 Plus program
- [**tetris-84.txt**](tetris-84.txt): formatted souce code
- [**tetris-84.md**](tetris-84.md): text tutorial (**outdated**)

## 3. Pause menu options

- **Return**: unpause
- **New**: start new game
- **Stop**: quit

## 4. Controls

- <kbd>On</kbd>: quit

### 4.1. Game

- <kbd>Window</kbd>: hold piece
- <kbd>Trace</kbd>: pause
- <kbd>2nd</kbd>: rotate clockwise
- <kbd>←</kbd>: move left
- <kbd>→</kbd>: move right
- <kbd>Alpha</kbd>: rotate counterclockwise
- <kbd>↓</kbd>: soft drop

### 4.2. Pause menu

- <kbd>Window</kbd>: select next option
- <kbd>Trace</kbd>: choose selected option
- <kbd>↵ Enter</kbd>: exit sleep mode

## 5. Features

1. **All tetrominoes**
2. **Alternative rotation**
3. **Animations**
4. **Drop**: soft drop
5. **Drop points**: `1 * fall_height`
6. **Drought prevention**: pieces are drawn from bags, except the first
7. **Easter eggs**: hold queue starts with a long bar
8. **Faster levels**: `speed = min(level, 9)`
9. **Game over detection**
10. **Game over screen**: fill animation, then pause
11. **Gravity**
12. **High scores**: top 3, updated (not refreshed) in real time
13. **Hold piece**: swap with next piece, indicated with `.`
14. **Horizontal movement**
15. **Level score multiplier**: `level + 1`
16. **Level selection**: start from level 0 - 9
17. **Line clearing**: animation
18. **Line clear points**:
    - **Single**: `40 * multiplier`
    - **Double**: `100 * multiplier`
    - **Triple**: `300 * multiplier`
    - **Tetris**: `1200 * multiplier`
19. **No bugs**
20. **No ceiling**
21. **Obstacle height selection**: start with height 0 - 14
22. **Pause**: menu with restart and quit
23. **Persistent high scores**: from OS
24. **Piece preview**: single piece
25. **Placement points**: 1
26. **Placement transition**: hide center of rotation
27. **Quit**: shows stack
28. **Restart**
29. **Retry**
30. **Rotation**
31. **Sleep mode**: activates after 1000 ticks of inactivity on pause screen
32. **Visible center of rotation**: indicated with `+`

## 6. Challenges

Here are some challenges, or try beating my high score 562,499:

1. *Single*: Clear a line
2. *Double*: Clear 2+ lines at once
3. *Triple*: Clear 3+ lines at once
4. *Tetris*: Clear 4 lines at once
5. *Double Tetris*: Clear 4 lines at once 2+ times in a row
6. *Quadruple Tetris*: Clear 4 lines at once 4+ times in a row
7. ***Octuple Tetris***: Clear 4 lines at once 8+ times in a row
    ***
8. *Clear 50*: Clear 50+ lines in a single game
9. *Clear 100*: Clear 100+ lines in a single game
10. ***Clear 200***: Clear 200+ lines in a single game
    ***
11. *Level Up 0*: Level up
12. *Level Up 1*: Level up starting from level 1+
13. *Level Up 2*: Level up starting from level 2+
14. *Level Up 3*: Level up starting from level 3+
15. *Level Up 4*: Level up starting from level 4+
16. *Level Up 5*: Level up starting from level 5+
17. *Level Up 6*: Level up starting from level 6+
18. *Level Up 7*: Level up starting from level 7+
19. *Level Up 8*: Level up starting from level 8+
20. ***Level Up 9***: Level up starting from level 9
    ***
21. *20K*: Earn a score of 20,000+
22. *50K*: Earn a score of 50,000+
23. *100K*: Earn a score of 100,000+
24. ***200K***: Earn a score of 200,000+
    ***
25. *Clean Up 2*: Clean up
26. *Clean Up 3*: Clean up height 3+
27. *Clean Up 4*: Clean up height 4+
28. *Clean Up 5*: Clean up height 5+
29. *Clean Up 6*: Clean up height 6+
30. *Clean Up 7*: Clean up height 7+
31. *Clean Up 8*: Clean up height 8+
32. *Clean Up 9*: Clean up height 9+
33. *Clean Up 10*: Clean up height 10+
34. *Clean Up 11*: Clean up height 11+
35. *Clean Up 12*: Clean up height 12+
36. *Clean Up 13*: Clean up height 13+
37. ***Clean Up 14***: Clean up height 14
    ***
38. ***No Rotation***: Clear 5+ lines without rotating
    ***
39. ***The 17th Line***: Clear a line above the screen
